from __future__ import with_statement

import es
import os
import sqlite3
import installlib
import cmdlib
import gamethread
# import zipfile
import datetime
import time
import re
from operator import truediv # I am not a real fan of __future__.division



update_check_enabled = True



info = es.AddonInfo()
info.basename = 'bansaver'
info.name = "BanSaver"
info.author = "Brainsucker"
info.description = "Saves NON-Permanent bans. So the bans will not expire after a server restart."
info.url = "http://addons.eventscripts.com/addons/view/bansaver"
info.version = "1.3.0"


def updatecheck():
	installer = installlib.getInstaller('bansaver')
	
	us = installer.update()
	
	if us == installer.STATUS_SUCCESSFUL:
		es.dbgmsg(0, '[%s] Updated to new Version (v%s). Please reload the Addon or restart your Server.' % (info['name'], installer.addon.currentversion))
	
	
addonpath = es.getAddonPath('bansaver')
dbpath = os.path.join(addonpath, 'banned.sql')
backup_basepath = os.path.join(addonpath, 'backups')

bantime_regex = re.compile(r'for ([\d.]+) minutes', re.I)

sql_db = sqlite3.connect(dbpath)
sql_cur = sql_db.cursor()


# def clear_db(args):
	# if args[0].lower() == 'help':
		# es.dbgmsg(0, 'Argument Syntax: <command> [backup]')
		# es.dbgmsg(0, '1. Argument: Defines if you want the script to create a backup of all bans.')
		# return
		
		
	# if args[0].lower() == 'backup':
		# bfp = os.path.join(backup_basepath, os.sep.join(time.strftime('%Y %B %d').split()))
		# if not os.path.isdir(bfp):
			# os.makedirs(bfp)
		
		# bfname = time.strftime('%H%M%S') + '.zip'
		# full_bfpath = os.path.join(bfp, bfname)
		# zfn = '%s.zip' % bfname
		# zf = zipfile.ZipFile(full_bfpath, mode='w')
		# zf.write(dbpath)
		# zf.close()
		
		
	# sql_cur.execute("DELETE FROM banned_user")
	# sql_db.commit()
	

def load():
	
	es.ServerVar(info["basename"]+'_ver', info["version"]).makepublic()
	
	
	# cmdlib.registerServerCommand('bansaver_cleardb', clear_db, 'Purges whole bansaver database. (USE WITH CAUTION!)')
	
	td = datetime.datetime.today()
	
	sql_cur.execute("CREATE TABLE IF NOT EXISTS banned_user (steamid TEXT UNIQUE, ip TEXT UNIQUE, expiredate REAL)")
	sql_cur.execute("SELECT * FROM banned_user")
	
	delay_time = 0.05 # Delay all bans a bit, when loading the addon. This will avoid a buffer overflow.
	
	
	expired_ip = set()
	expired_id = set()
	
	while True:
		next = sql_cur.fetchone()
		if not next:
			break
		user_steamid, user_ip, expiredate_timestamp = next
		expiredate_datetime = datetime.datetime.fromtimestamp(expiredate_timestamp)
		
		if td < expiredate_datetime:
			delay_time += 0.05
			remaining_bantime = expiredate_datetime - td
			remaining_days = remaining_bantime.days
			remaining_seconds = remaining_bantime.seconds + (remaining_days*86400)
			remaining_minutes = truediv(remaining_seconds, 60)
			if user_steamid:
				gamethread.delayed(delay_time, es.server.queuecmd, ("banid %f %s" % (remaining_minutes, user_steamid)))
				
			if user_ip:
				gamethread.delayed(delay_time, es.server.queuecmd, ('addip %f %s' % (remaining_minutes, user_ip)))
				
		else:
			if user_steamid:
				expired_id.add(user_steamid)
				
			if user_ip:
				expired_ip.add(user_steamid)
				
	for s in expired_id:
		sql_cur.execute("DELETE FROM banned_user WHERE steamid=?", (s,))
		
	for e in expired_ip:
		sql_cur.execute("DELETE FROM banned_user WHERE ip=?", (e,))
		
	sql_db.commit()
	
# def unload():
	# cmdlib.unregisterServerCommand('bansaver_cleardb')
	

def es_map_start(ev):
	if update_check_enabled:
		updatecheck()


def server_addban(ev):
	steamid = ev["networkid"]
	ip = ev['ip']
	dur = ev["duration"]
	m = bantime_regex.match(dur)
	if m:
		bantime = float(m.group(1))
		if bantime > 0:
			ed = time.time() + (bantime * 60)
			if steamid:
				sql_cur.execute("SELECT * FROM banned_user WHERE steamid=?", (steamid,))
				steamid_result = sql_cur.fetchone()
				if steamid_result:
					user_sid, user_ip, user_expiredate = steamid_result
					sql_cur.execute("UPDATE banned_user SET expiredate=? WHERE steamid=?", (ed, steamid))
				else:
					sql_cur.execute("INSERT INTO banned_user(steamid, expiredate) VALUES(?, ?)", (steamid, ed))
					
			if ip:
				sql_cur.execute("SELECT * FROM banned_user WHERE ip=?", (ip,))
				ip_result = sql_cur.fetchone()
				if ip_result:
					user_sid, user_ip, expiredate = ip_result
					sql_cur.execute("UPDATE banned_user SET expiredate=? WHERE ip=?", (ed, ip))
				else:
					sql_cur.execute("INSERT INTO banned_user(ip, expiredate) VALUES(?, ?)", (ip, ed))
					
			sql_db.commit()
			
def server_removeban(ev):
	steamid = ev["networkid"]
	ip = ev['ip']
	if steamid:
		sql_cur.execute("SELECT * FROM banned_user WHERE steamid=?", (steamid,))
		steamid_result = sql_cur.fetchone()
		if steamid_result:
			sql_cur.execute("DELETE FROM banned_user WHERE steamid=?", (steamid,))
			sql_db.commit()
	if ip:
		sql_cur.execute("SELECT * FROM banned_user WHERE ip=?", (ip,))
		ip_result = sql_cur.fetchone()
		if ip_result:
			sql_cur.execute("DELETE FROM banned_user WHERE ip=?", (ip,))
			sql_db.commit()